<?
/** OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

define("AREA", "admin");

include_once "../lib/admin_init.inc.php";

	// Loading TPLs
	$page = tpl_load("body");
	$page_menu = tpl_load("menu");
	
	// Insert Menu
	tpl_set($page, "[MENU]", $page_menu);

	if(@$_POST['createacc'] != "")
	{
		$page_content = tpl_load("create_account");

		
		tpl_set($page_content, "[name]", $_POST['name']);
		tpl_set($page_content, "[node]", $_POST['node']);
		tpl_set($page_content, "[password]", $_POST['password']);

		$ips = "";

		foreach($_POST['ips'] as $key => $ip)
		{				
			$ips .= '<input type=hidden name="ips['.$key.'][1]" value="'.$ip[1].'">';
			$ips .= '<input type=hidden name="ips['.$key.'][2]" value="'.$ip[2].'">';
			$ips .= '<input type=hidden name="ips['.$key.'][0]" value="'.$ip[0].'">';
			$ips .= '<input type=hidden name="ips['.$key.'][3]" value="'.$ip[3].'">';
			$ips .= '<input type=hidden name="ips['.$key.'][4]" value="'.$ip[4].'">';
				
		}
	
		tpl_set($page_content, "[ips]", $ips);


		$page = str_replace("[CONTENT]", $page_content, $page);
					
		echo $page;
		
	}
	elseif(isset($_POST['makeacc']) && $_POST['makeacc'] != "")
	{
		$page_content = tpl_load("message");

		$_POST['name'] =  mysql_escape_safe($_POST['name']);
		$_POST['firstname'] =  mysql_escape_safe($_POST['firstname']);
		$_POST['lastname'] =  mysql_escape_safe($_POST['lastname']);
		$_POST['street'] =  mysql_escape_safe($_POST['street']);
		$_POST['city'] =  mysql_escape_safe($_POST['city']);
		$_POST['postcode'] =  mysql_escape_safe($_POST['postcode']);
		$_POST['tel'] =  mysql_escape_safe($_POST['tel']);
		$_POST['email'] =  mysql_escape_safe($_POST['email']);
		$_POST['node'] =  mysql_escape_safe($_POST['node']);

		mysql_query("INSERT into users 
					SET
					name = '$_POST[name]',
					firstname = '$_POST[firstname]',
					lastname = '$_POST[lastname]',
					street = '$_POST[street]', 
					city = '$_POST[city]', 
					postcode = '$_POST[postcode]', 
					tel = '$_POST[tel]', 
					email = '$_POST[email]', 
					password = md5('$_POST[password]'),
					node = '$_POST[node]'
					") OR error_page("Database Error");
	
		$page_content = str_replace("[TYPE]", "Notice", $page_content);			
		$page_content = str_replace("[MESSAGE]", "User Account created<br><br><table><tr><td>User:</td><td>$_POST[name]</td></tr><tr><td>Password:</td><td>$_POST[password]</td></tr></table>", $page_content);

		
		$page = str_replace("[CONTENT]", $page_content, $page);
		
		echo $page;

	}
	elseif(@$_POST['create'] != "")
	{

		// Connect to Node
		$hardware_node = get_node_by_id($_POST['node']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);	
	
		if($_POST['name'] != "" &&  $_POST['hostname'] != "" &&  $_POST['space'] != "" &&  $_POST['cpu'] != "" && $_POST['image'] != "" && $socket != NULL)
		{


			set_time_limit (0);
			ob_implicit_flush ();
	


			$page_content = tpl_load("create_action");
					
			$root_password = create_password();
	
			tpl_set($page_content, "[name]", $_POST['name']);
			tpl_set($page_content, "[node]", $_POST['node']);
			tpl_set($page_content, "[password]", $root_password[0]);

			$ips = "";

			if(isset($_POST['ips']))
			{
				foreach($_POST['ips'] as $key => $ip)
				{				
					$ips .= '<input type=hidden name="ips['.$key.'][1]" value="'.$ip[1].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][2]" value="'.$ip[2].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][0]" value="'.$ip[0].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][3]" value="'.$ip[3].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][4]" value="'.$ip[4].'">';
				}	
			}
	
			tpl_set($page_content, "[ips]", $ips);



			tpl_set($page, "[CONTENT]", $page_content);


			echo $page;


								
			htmlelement_set("output", "\\r\\n");
			htmlelement_set("result", "\\r\\n");

		
			//CONFIG
			htmlelement_add("output", "Creating Config Files...\\r\\n");
			$status = vcp_exec($socket, "SETUP CONFIG $_POST[name]");
			htmlelement_add("result", $status."\\r\\n");

			// INTERFACES
			htmlelement_add("output", "Creating Interfaces...\\r\\n");	

			if(isset($_POST['ips']))
			{
				foreach($_POST['ips'] as $key => $rawip)
				{
					if($rawip[0] != "" && $rawip[1] != "" && $rawip[2] != "" && $rawip[3] != "" && $rawip[4] != "")
					{

						
						$ip  = $rawip[0];
						$dev   = $rawip[1];
						$alias   = $rawip[2];
						$mask  =  $rawip[3];
						$bcast  = $rawip[4];

						$status = vcp_exec($socket, "SET IP_ADD {$_POST['name']} $ip $dev $alias $mask $bcast");
					}
				}
			}
			
			htmlelement_add("result", $status."\\r\\n");

			//CPU LIMIT
			if($_POST['cpu'] != 0)
			{
				$limit = (32/100)*$_POST['cpu'];
				htmlelement_add("output", "Setting CPU Limit ...\\r\\n");			
				$status = vcp_exec($socket, "SET SCHEDULE $_POST[name] $limit");	
				htmlelement_add("result", $status."\\r\\n");
			}		

			//RLIMIT
			if($_POST['rss'] != 0)
			{
				$rss = 1024/4*$_POST['rss'];
				htmlelement_add("output", "Setting RSS Limit ...\\r\\n");			
				$status = vcp_exec($socket, "SET RLIMIT $_POST[name] rss $rss");	
				htmlelement_add("result", $status."\\r\\n");
			}		

			if($_POST['vm'] != 0)
			{
				$vm = 1024/4*$_POST['vm'];
				htmlelement_add("output", "Setting VM Limit ...\\r\\n");			
				$status = vcp_exec($socket, "SET RLIMIT $_POST[name] as $vm");	
				htmlelement_add("result", $status."\\r\\n");
			}		

			//FLAGS
			htmlelement_add("output", "Setting Flags ...\\r\\n");			
			$flags = "";
			foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load' ) as $flag )
			{
				if ( $_POST[$flag] == "1" )
					$status = vcp_exec($socket, "SET FLAG_ADD $_POST[name] $flag");
				if ( $status != 'OK')
					break;
					
			}
			htmlelement_add("result", $status."\\r\\n");
			
			//IMAGE		
			htmlelement_add("output", "Installing Image...\\r\\n");
			$status = vcp_exec($socket, "SETUP IMAGE $_POST[name] $_POST[image]");
			htmlelement_add("result", $status."\\r\\n");

			//HOSTNAME
			htmlelement_add("output", "Setting Hostname...\\r\\n");			
			$status = vcp_exec($socket, "SET HOSTNAME $_POST[name] $_POST[hostname]");	
			htmlelement_add("result", $status."\\r\\n");			
			
			//ROOT PASS
			htmlelement_add("output", "Setting Root Password...\\r\\n");
			$status = vcp_exec($socket, "SET ROOTPASS $_POST[name] $root_password[1]");	
			htmlelement_add("result", $status."\\r\\n");			

			//SPACE
			htmlelement_add("output", "Setting Disk Limit...\\r\\n");			
			$status = vcp_exec($socket, "SET SPACE $_POST[name] ".($_POST['space']*1024)." 1000000");	
			htmlelement_add("result", $status."\\r\\n");
		
			//START VS
			htmlelement_add("output", "Starting VServer...");
			$status = vcp_exec($socket, "CONTROL START ".$_POST['name']);	
			htmlelement_add("result", "OK\\r\\n");		
			
			htmlelement_set("message", "VServer created successfully\\r\\nRoot Password: $root_password[0]");
								
			htmlelement_hide("loadimg");
			htmlelement_unhide("createacc");	


		}		
		else
		{
			$page_content = tpl_load("message");

			tpl_set($page_content, "[TYPE]", "Error");

			if($socket != NULL)
			{
				tpl_set($page_content, "[MESSAGE]", "The form is incomplete");
			}
			else
			{
				tpl_set($page_content, "[MESSAGE]", "Could not connect to Node");
			}

		}	
			
	}

	elseif(isset($_POST['ressources']))
	{
		$page_content = tpl_load("create_ressources");
		
		tpl_set($page_content, "[node]", $_POST['node']);
		tpl_set($page_content, "[name]", $_POST['name']);
		tpl_set($page_content, "[hostname]", $_POST['hostname']);
		tpl_set($page_content, "[image]", $_POST['image']);
		tpl_set($page_content, "[sched_hard]", $_POST['sched_hard']);
		tpl_set($page_content, "[virt_mem]", $_POST['virt_mem']);
		tpl_set($page_content, "[virt_cpu]", $_POST['virt_cpu']);
		tpl_set($page_content, "[virt_load]", $_POST['virt_load']);
		tpl_set($page_content, "[virt_uptime]", $_POST['virt_uptime']);
		tpl_set($page_content, "[cpulimit]", ( $_POST['sched_hard'] ) ? '' : ' readonly="1"');
		
		
		$ips = "";

		if(isset($_POST['ips']))
		{
		
			foreach($_POST['ips'] as $key => $ip)
			{
					
				$ips .= '<input type=hidden name="ips['.$key.'][1]" value="'.$ip[1].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][2]" value="'.$ip[2].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][0]" value="'.$ip[0].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][3]" value="'.$ip[3].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][4]" value="'.$ip[4].'">';
			}
					
		}

		tpl_set($page_content, "[ips]", $ips);
		
		
		tpl_set($page, "[CONTENT]", $page_content);
		echo $page;
		
	}

	elseif(isset($_POST['flags']))
	{
		$page_content = tpl_load("create_flags");
		foreach( array( 'sched_hard', 'virt_mem', 'virt_uptime', 'virt_cpu', 'virt_load' ) as $flag )
		{
			$options = '<option value="0">No</option><option value="1"';
			$options .= (@$_POST[$flag]=="1") ? ' selected="1"' : '';
			$options .= '>Yes</option>';
			tpl_set($page_content, "[$flag]", $options);
		}
		
		tpl_set($page_content, "[node]", $_POST['node']);
		tpl_set($page_content, "[name]", $_POST['name']);
		tpl_set($page_content, "[hostname]", $_POST['hostname']);
		tpl_set($page_content, "[image]", $_POST['image']);

		$ips = "";

		if(isset($_POST['ips']))
		{
			foreach($_POST['ips'] as $key => $ip)
			{
					
				$ips .= '<input type=hidden name="ips['.$key.'][1]" value="'.$ip[1].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][2]" value="'.$ip[2].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][0]" value="'.$ip[0].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][3]" value="'.$ip[3].'">';
				$ips .= '<input type=hidden name="ips['.$key.'][4]" value="'.$ip[4].'">';
				
			}

		}
		
		tpl_set($page_content, "[ips]", $ips);
		
		tpl_set($page, "[CONTENT]", $page_content);
		echo $page;
		
	}

	elseif(isset($_POST['interfaces']) || isset($_POST['addip']) || isset($_POST['delip']))
	{

		$hardware_node = get_node_by_id($_POST['node']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);

		$_POST['name'] = trim($_POST['name']);

		$vserver_list = vcp_exec($socket, "LIST");
		$vservers = explode(" ", $vserver_list);

		foreach($vservers as $vserver)
		{
			$vserver = trim($vserver);
			if($_POST['name'] == $vserver)
			{
				$exist = TRUE;
				break;
			}
		}

		if($_POST['name'] != "" &&  $_POST['hostname'] != "" &&  $socket != NULL && @$exist != TRUE)
		{
			$page_content = tpl_load("create_interfaces");
			$ips = "";
								
								
			$rawips = @$_POST['ips'];
								

			if(isset($_POST['addip']))
			{


				if($_POST['addip'] != "" && $_POST['ip'] != "")
				{

				
					$dev = $_POST['dev'];

					$ip = $_POST['ip'];
					$bcast = (@$_POST['setbcast'] == 'on') ? $_POST['bcast'] : "nobcast";
					$mask = ($_POST['netmask'] != "") ? $_POST['netmask'] : "nomask";
				
					$ips .= $_POST['ip']." - ".$_POST['dev']." ";
					
						
					if(@$_POST['ownalias'] == 'on')
					{
						$alias =  $_POST['alias'];
					}
					elseif($_POST['dev'] == 'nodev')
					{
						$alias = 'noname';
						$mask =  'nomask';
						$bcast = 'nobcast';
					}
					else
					{
						
						if($rawips != "")
						{
						
							$i = 0;
							$current_interface_names = array();

							foreach($rawips as $interface)
							{	
								$current_interface_names[$i] = $interface[2];
								$i++;
							}						

							$i = 0;
							do
							{
								$alias = $_POST['name'].$i;	
								$i++;
							}
							while(in_array ($alias, $current_interface_names));
						}
						else
						{
							$alias = $_POST['name'].'0';
						}
					}
									
					$num = count($rawips);
					$rawips[$num][0] = $ip;
					$rawips[$num][1] = $dev;
					$rawips[$num][2] = $alias;
					$rawips[$num][3] = $mask;
					$rawips[$num][4] = $bcast;
				}
			}
			else
			if(isset($_POST['delip']))
			{
				foreach($rawips as $ip_key => $ip)
				{
			
					foreach($_POST['ip2del'] as $ip2del)
					{
						if($ip2del == $ip[0])
						{
							unset($rawips[$ip_key]);
							break;
						}
					}
					
					
				}
				
				$i = 0;
				foreach($rawips as $ip_key => $ip)
				{
					$rawips_clean[$i] = $ip;
					$i++;
				}
				unset($rawips);
				$rawips = $rawips_clean;
			}
			
			$ips_used = "";
			
			if(isset($rawips))
			{
				foreach($rawips as $ip_key => $ip)
				{
					$ips_used .= $ip[0];
				}
			}
			
			tpl_set($page_content, "[ip]", create_availableip_dropdown($ips_used));

			$image_list = vcp_exec($socket, "NODE IMAGES");
			$image_list = explode(" ", $image_list);
			
			$images = "";

			foreach($image_list as $image)
			{
				if($image != "")
				{

					if(@$_POST['image'] == $image)
					{
						$images .= "<option selected>$image</option>";
					}	
					else
					{
						$images .= "<option>$image</option>";
					}
				}
			}



			$interface_list = vcp_exec($socket, "NODE INTERFACES");
			$interface_list = explode(" ", $interface_list);
			
			$interfaces = "";

			foreach($interface_list as $interface)
			{

				$interfaces .= '<option>'.$interface.'</option>';
	
			}

			tpl_set($page_content, "[interfaces]", $interfaces);
			tpl_set($page_content, "[images]", $images);

			tpl_set($page_content, "[node]", $_POST['node']);
			tpl_set($page_content, "[name]", $_POST['name']);
			tpl_set($page_content, "[hostname]", $_POST['hostname']);
			
	

			$ips = '<br><table  width=500>';
			$ips .= '<tr align=left><th>Device</th><th>Alias</th><th>IP</th><th>Mask</th><th>Bcast</th></tr>';
		

			if(isset($rawips))
			{


				foreach($rawips as $key => $ip)
				{
				
					
					$ips .= '<input type=hidden name="ips['.$key.'][1]" value="'.$ip[1].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][2]" value="'.$ip[2].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][0]" value="'.$ip[0].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][3]" value="'.$ip[3].'">';
					$ips .= '<input type=hidden name="ips['.$key.'][4]" value="'.$ip[4].'">';
					
							
					if($ip[2] == 'noname')
						$ip[2] = "";
					if($ip[3] == 'nomask')
						$ip[3] = "";
					if($ip[4] == 'nobcast')
						$ip[4] = "";
				
					$ips .= '<tr>';
					$ips .= '<td>'.$ip[1].'</td>';			
					$ips .= '<td>'.$ip[2].'</td>';			
					$ips .= '<td>'.$ip[0].'</td>';			
					$ips .= '<td>'.$ip[3].'</td>';			
					$ips .= '<td>'.$ip[4].'</td>';			
					$ips .= '<td><input name="ip2del['.$key.']" value="'.$ip[0].'" type="checkbox"></td>';					
					$ips .= '</tr>';
		
					
				}


			}

			$ips .= "</table>";			
			
			tpl_set($page_content, "[ips]", $ips);

		}
		else
		{
			$page_content = tpl_load("message");
			tpl_set($page_content, "[TYPE]", "Error");

			if($socket != NULL)
			{
				if(@$exist == TRUE)
				{
					tpl_set($page_content, "[MESSAGE]", "VServer already exist");
				}
				else
				{
					tpl_set($page_content, "[MESSAGE]", "The form is incomplete");
				}
			}
			else
			{
				tpl_set($page_content, "[MESSAGE]", "Could not connect to Node");
			}
		}


		tpl_set($page, "[CONTENT]", $page_content);

		echo $page;
	}
	else
	{
	
	
		$page_content = tpl_load("create");
	
	
		
		$mysql_id = mysql_query("SELECT id, name FROM nodes ORDER by id") OR error_page("Database Error");
	
		$nodes = "";

		while(($mysql_result = mysql_fetch_assoc($mysql_id)) != NULL)
		{
			if(isset($_POST['node']) && $_POST['node'] == $mysql_result['id'])
			{
				$nodes .= "<option selected value=\"$mysql_result[id]\">$mysql_result[name]</option>";
			}
			else
			{
				$nodes .= "<option value=\"$mysql_result[id]\">$mysql_result[name]</option>";
			}
		}
	

		tpl_set($page_content, "[nodes]", $nodes);			


		
		
		tpl_set($page, "[CONTENT]", $page_content);

		
		echo $page;
	}	
	
?>
