<?
/**  OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
	define("AREA", "user");

	include_once "lib/init.inc.php";

		// Loading TPLs
		$page = tpl_load("body");
		$page_menu = tpl_load("menu");
		
		// Insert Menu
		$page = str_replace("[menu]", $page_menu, $page);

		// Connect to Node
		$hardware_node = get_node($_SESSION['user']);

		if(($socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support'])) != FALSE)
		{
			$page_content = tpl_load("state");


			// GRAB vServer Infos
		
			$page_content = str_replace("[name]", $_SESSION['user'], $page_content);
		
			$rawips = vcp_exec($socket, "GET IPS ".$_SESSION['user']);
			$rawips = eth_split($rawips);
	
			$ips = "";
			foreach($rawips as $ip)
			{
				$ips .= "$ip[0]<br>";
			
			}

			$month = date("m");
			$traffic = vcp_exec($socket, "TRAFFIC ".$_SESSION['user']." ".$month." TOTAL");
			$traffic = number_format($traffic/1000/1000/1000, 2);

        	      	$space = vcp_exec($socket, "GET SPACE ".$_SESSION['user']);
		   	$space = explode(" ", $space);               

      	                if($space[0] == -1)
	                        $space[0] = "N/A";
	                if($space[1] == -1)
        	                $space[1] = "N/A";
        	        if($space[2] == -1)
             	  	        $space[2] = "N/A";


		  	tpl_set($page_content, "[space_size]", $space[0]);			
		 	tpl_set($page_content, "[space_used]", $space[1]);	
		 	tpl_set($page_content, "[space_avail]", $space[2]);		


			tpl_set($page_content, "[ips]", $ips);
			tpl_set($page_content, "[traffic]", $traffic." GB");
			
			$state = vcp_exec($socket, "GET STATE ".$_SESSION['user']);	
			tpl_set($page_content, "[state]", $state);
	
		}
		else
		{
				$page_content = tpl_load("message");
				tpl_set($page_content, "[type]", "Error");
				tpl_set($page_content, "[message]", "Couldn't connect to node");
		}

		
		$page = str_replace("[content]", $page_content, $page);
		
	
	
	
	echo $page;
	
?>
