<?
/**  
 * OpenVCP Webinterface
 * Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 * @author  OpenVCP Team
 * @version 0.2
 * @package OpenVCP-v0.2
 */

	include_once "../config.inc.php";

	mysql_connect($mysql_host, $mysql_user, $mysql_pw) OR die("Connecting to Database failed, please make sure, that you entered the informations correctly");
	mysql_select_db($mysql_db) OR die("Selecting DB failed, please make sure, that you entered the informations correctly");

	echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
		<html>
		<head>
  			<meta content=\"text/html; charset=ISO-8859-1\" http-equiv=\"content-type\">
  			<title>OpenVCP Installation</title>
		</head>
		<body>
			<img alt=\"\" src=\"../images/logo.png\">";

	echo "<fieldset style=\"border-width:1px;border-color:black\">";
	echo "<legend>Installation</legend>
		<center>
		<br>";
	echo "<h2>Welcome to the webinterface installer!</h2><br><br>";
	echo "Please make sure, that you have edited config.php correct!<br>";

	echo "Starting to create nodes table <br>";
	mysql_query("CREATE TABLE `nodes` (
			`id` int(11) NOT NULL auto_increment,
			`name` tinytext NOT NULL,
			`ip` varchar(16) NOT NULL default '',
			`password` tinytext NOT NULL,
			`tls_support` char(1) NOT NULL default 'n',
			PRIMARY KEY  (`id`)
			) ENGINE=MyISAM;");
	echo "Done creating nodes table<br><br>";

	echo "Starting to create options table <br>";
	mysql_query("CREATE TABLE `options` (
			`admin_password` tinytext NOT NULL,
			`version` varchar(10) NOT NULL default ''
			) ENGINE=MyISAM;");
	echo "Done creating options table<br><br>";

	echo "Inserting Options<br>";
	mysql_query("INSERT INTO `options` (`admin_password`, `version`) VALUES ('098f6bcd4621d373cade4e832627b4f6', '0.2');");
	echo "Done inserting options<br><br>";

	echo "Starting to create users table <br>";
	mysql_query("CREATE TABLE `users` (
			`id` int(11) NOT NULL auto_increment,
			`name` tinytext NOT NULL,
			`password` tinytext NOT NULL,
			`firstname` tinytext NOT NULL,
			`lastname` tinytext NOT NULL,
			`street` tinytext NOT NULL,
			`city` tinytext NOT NULL,
			`postcode` tinytext NOT NULL,
			`tel` tinytext NOT NULL,
			`email` tinytext NOT NULL,
			`node` int(11) NOT NULL default '0',
			`adminid` int(11) NOT NULL default '0',
			PRIMARY KEY  (`id`)
			) ENGINE=MyISAM;");

	echo "Done creating users table<br><br>";

	echo "Starting to create navigations table <br>";
	mysql_query("CREATE TABLE `navigation` (
			`id` int(11) NOT NULL auto_increment,
			`name` tinytext NOT NULL,
			`section` tinytext NOT NULL,
			`link` varchar(255) NOT NULL default '',
			`image` varchar(255) NOT NULL default '',
			`order` int(4) NOT NULL default '0',
			`area` tinytext NOT NULL,
			PRIMARY KEY  (`id`)
			) ENGINE=MyISAM;");

	echo "Done creating navigations table<br><br>";

	echo "Inserting navigation elements<br>";
	mysql_query("INSERT INTO `navigation` (`id`, `name`, `section`, `link`, `image`, `order`, `area`) VALUES 
			(1, 'Info', '', '', '', 10, 'user'),
			(2, 'Traffic', 'Info', 'traffic.php', 'images/traffic.gif', 10, 'user'),
			(3, 'Status', 'Info', 'index.php', 'images/status.gif', 0, 'user'),
			(4, 'Control', '', '', '', 20, 'user'),
			(5, 'Start/Stop', 'Control', 'startstop.php', 'images/vs.gif', 10, 'user'),
			(6, 'Reinstall', 'Control', 'reinstall.php', 'images/reinstall.gif', 20, 'user'),
			(7, 'Options', '', '', '', 30, 'user'),
			(8, 'Personal Data', 'Options', 'personal.php', 'images/personal.gif', 10, 'user'),
			(9, 'Password', 'Options', 'password.php', 'images/password.gif', 20, 'user'),
			(10, 'Logout', 'Options', 'login.php?user', 'images/del.gif', 100, 'user'),
			(11, 'Nodes', '', '', '', 10, 'admin'),
			(12, 'Overview', 'Nodes', 'index.php', '../images/node.gif', 10, 'admin'),
			(13, 'Add Node', 'Nodes', 'add_node.php', '../images/addnode.gif', 20, 'admin'),
			(14, 'Network', '', '', '', 20, 'admin'),
			(15, 'Overview', 'Network', 'manage_networks.php', './../images/network.png', 10, 'admin'),
			(16, 'Add Network', 'Network', 'manage_networks.php?page=addiprange', '../images/reinstall.gif', 20, 'admin'),
			(17, 'vServer', '', '', '', 20, 'admin'),
			(18, 'Overview', 'vServer', 'vserver.php', '../images/vs.gif', 10, 'admin'),
			(19, 'Add vServer', 'vServer', 'create_vserver.php', '../images/reinstall.gif', 20, 'admin'),
			(20, 'Users', '', '', '', 40, 'admin'),
			(21, 'Overview', 'Users', 'manage_users.php', './../images/users.png', 10, 'admin'),
			(22, 'Add User', 'Users', 'manage_users.php?page=add', './../images/adduser.png', 20, 'admin'),
			(23, 'Options', '', '', '', 50, 'admin'),
			(24, 'Password', 'Options', 'password.php', '../images/password.gif', 10, 'admin'),
			(25, 'Logout', 'Options', '../login.php?admin', '../images/del.gif', 100, 'admin');");
	echo "Done inserting navigation elements<br><br>";

	echo "Starting to create networks table <br>";
	mysql_query("CREATE TABLE `networks` (
			`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`ip` VARCHAR( 20 ) NOT NULL ,
			`used` TINYINT( 1 ) NOT NULL DEFAULT '0',
			`vserver` VARCHAR( 255 ) NOT NULL ,
			`node` INT( 11 ) NOT NULL , 
			`can_see_nodes` INT( 1 ) NULL, 
			`can_add_node` INT( 1 ) NULL 
			) ENGINE = MYISAM ;");

	echo "Done creating networks table<br><br>";

	echo "Starting to create admin table<br>";
	mysql_query("CREATE TABLE `admins` (
			`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`name` VARCHAR( 255 ) NOT NULL ,
			`traffic_total` INT( 20 ) NOT NULL ,
			`space_total` INT( 20 ) NOT NULL ,
			`vserver_total` INT( 10 ) NOT NULL ,
			`node` INT( 11 ) NOT NULL
			) ENGINE = MYISAM ;");

	echo "Done creating admin table<br><br>";

	echo "Installed every necessary table<br>";

	echo "Please delete this script and after that you can login with username \"Admin\" and password \"test\"";
	echo "<br>
		</center>
		</fieldset>
		</body>
		</html>";

?>
