<?
/**  OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
	define("AREA", "user");

	include_once "lib/init.inc.php";

		// Loading TPLs
		$page = tpl_load("body");
		$page_menu = tpl_load("menu");
		
		// Insert Menu
		tpl_set($page, "[menu]", $page_menu);
			
		// Connect to Node
		$hardware_node = get_node($_SESSION['user']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);

		if($socket != FALSE)
		{

			if(isset($_POST['reinstall']) && $_POST['image'] != "")
			{
				set_time_limit (0);
				ob_implicit_flush ();
				
	
				$page_content = tpl_load("reinstall_action");
				
				tpl_set($page, "[content]", $page_content);
				echo $page;
				
				$status = vcp_exec($socket, "GET STATE ".$_SESSION['user']);
	
				htmlelement_set("output", "\\r\\n");
				htmlelement_set("result", "\\r\\n");
				
	
				if($status == "Online")
				{
					htmlelement_add("output", "Stopping VServer...\\r\\n");		
					$status = vcp_exec($socket, 'CONTROL STOP '.$_SESSION['user']);	
					htmlelement_add("result", "OK\\r\\n");
				}
				
	
				
				htmlelement_add("output", "Installing new Image...\\r\\n");
				$status = vcp_exec($socket, 'SETUP IMAGE '.$_SESSION['user'].' '.$_POST['image']);
				htmlelement_add("result", $status."\\r\\n");
				
	
				if($status == "OK")
				{
				
					htmlelement_add("output", "Setting Root Password...\\r\\n");
					$root_password = create_password();
					$status = vcp_exec($socket, 'SET ROOTPASS '.$_SESSION['user'].' '.$root_password[1]);	
					htmlelement_add("result", $status."\\r\\n");
				
					htmlelement_add("output", "Starting VServer...");
					$status = vcp_exec($socket, 'CONTROL START '.$_SESSION['user']);	
					htmlelement_add("result", "OK\\r\\n");		
	
				
					htmlelement_set("message", "Installation completed successfully\\r\\n New Root Password: $root_password[0]");
					
					
					htmlelement_hide("loadimg");	
	
				}
				else
				{
					htmlelement_style("result", "color", "red");
					htmlelement_set("message", "An Error occurred");
					htmlelement_hide("loadimg");	
				
				}
				
			}
			else
			{
				$page_content = tpl_load("reinstall");
	
				
				tpl_set($page_content, "[name]", $_SESSION['user']);
				
				$image_list = vcp_exec($socket, "NODE IMAGES");
				$image_list = trim($image_list);
				$image_list = explode(" ", $image_list);

				$images = "";

				foreach($image_list as $image)
				{
					$images .= '<option>'.$image.'</option>';
				}
				
				tpl_set($page_content, "[images]", $images);
				
				
				tpl_set($page, "[content]", $page_content);
			
				echo $page;
	
			}
	
		}
		else
		{
				$page_content = tpl_load("message");
				tpl_set($page_content, "[type]", "Error");
				tpl_set($page_content, "[message]", "Couldn't connect to node");

				tpl_set($page, "[content]", $page_content);
			
				echo $page;
		}
	
	
	
?>
