<?
/**  OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
	define("AREA", "user");

	include_once "lib/init.inc.php";

		// Loading TPLs
		$page = tpl_load("body");
		$page_menu = tpl_load("menu");
		
		// Insert Menu
		$page = str_replace("[menu]", $page_menu, $page);
			
		// Connect to Node
		$hardware_node = get_node($_SESSION['user']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);
		
		if($socket != FALSE)
		{

			if(isset($_GET['start']))
			{
				if(vcp_exec($socket, 'GET STATE '.$_SESSION['user']) == 'Online')
				{
					$page_content = tpl_load("message");
					tpl_set($page_content, "[message]", "The VServer is already running");
					
					tpl_set($page, "[content]", $page_content);

					echo $page;		
				}
				else
				{
					ob_implicit_flush ();
	
					$page_content = tpl_load("startstop_action");
					tpl_set($page_content, "[action]", "Starting");
				
					$page = str_replace("[content]", $page_content, $page);
					echo $page;
				
					$bootlog = vcp_exec($socket, 'CONTROL START '.$_SESSION['user']);
					$bootlog = str_replace("\n", "\\r\\n", $bootlog);
					
					htmlelement_set("output", "\\r\\n");				
					htmlelement_add("output", $bootlog);
					htmlelement_unhide("outputtable");
	
					htmlelement_hide("message");
					htmlelement_hide("loadimg");
	
				}
			}
			elseif(isset($_GET['stop']))
			{
				if(vcp_exec($socket, 'GET STATE '.$_SESSION['user']) == 'Offline')
				{
					$page_content = tpl_load("message");
					$page_content = str_replace("[message]", "The VServer is not running", $page_content);
					
					$page = str_replace("[content]", $page_content, $page);
					echo $page;		
				}
				else
				{
					ob_implicit_flush ();
	
					$page_content = tpl_load("startstop_action");
					$page_content = str_replace("[action]", "Stopping", $page_content);
				
					$page = str_replace("[content]", $page_content, $page);
					echo $page;
				
					$bootlog = vcp_exec($socket, 'CONTROL STOP '.$_SESSION['user']);
					$bootlog = str_replace("\n", "\\r\\n", $bootlog);
					
					htmlelement_set("output", "\\r\\n");				
					htmlelement_add("output", $bootlog);
					htmlelement_unhide("outputtable");
					
					htmlelement_hide("message");
					htmlelement_hide("loadimg");
				}
			}
			elseif(isset($_GET['reboot']))
			{
				if(vcp_exec($socket, 'GET STATE '.$_SESSION['user']) == 'Offline')
				{
					$page_content = tpl_load("message");
					tpl_set( $page_content, "[type]", "Notice");
					tpl_set( $page_content, "[message]", "The VServer is not running");
					
					tpl_set($page, "[content]", $page_content);
					echo $page;		
				}
				else
				{		
			
					ob_implicit_flush ();
	
					$page_content = tpl_load("startstop_action");
					tpl_set($page_content, "[action]", "Reboot");
				
					tpl_set($page, "[content]", $page_content);
					echo $page;
				
					$bootlog = vcp_exec($socket, 'CONTROL STOP '.$_SESSION['user']);
					$bootlog .= vcp_exec($socket, 'CONTROL START '.$_SESSION['user']);
		
					$bootlog = str_replace("\n", "\\r\\n", $bootlog);
					
					htmlelement_set("output", "\\r\\n");				
					htmlelement_add("output", $bootlog);
					htmlelement_unhide("outputtable");
	
					htmlelement_hide("message");
					htmlelement_hide("loadimg");
				}
			}
			else
			{
				$page_content = tpl_load("startstop");
	
	
				
				tpl_set($page_content, "[name]", $_SESSION['user']);
			
	
				$state = vcp_exec($socket, 'GET STATE '.$_SESSION['user']);
				tpl_set($page_content, "[state]", $state);
			
				$page = str_replace("[content]", $page_content, $page);
			
				echo $page;
		
	
			}
	
		}
		else
		{
			$page_content = tpl_load("message");
			tpl_set($page_content, "[type]", "Error");
			tpl_set($page_content, "[message]", "Couldn't connect to node");
			$page = str_replace("[content]", $page_content, $page);
			
			echo $page;

		}


	

	
?>
