<?
/**  OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
	define("AREA", "user");

	include_once "lib/init.inc.php";

		// Loading TPLs
		$page = tpl_load("body");
		$page_menu = tpl_load("menu");
		$page_content = tpl_load("traffic");
		
		// Insert Menu
		tpl_set($page, "[menu]", $page_menu);

		// Connect to Node
		$hardware_node = get_node($_SESSION['user']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);
		
		if($socket != FALSE)
		{

		
			//GET IPS
			$rawips = vcp_exec($socket, "GET IPS ".$_SESSION['user']);

			$rawips = eth_split($rawips);
	
			$ips = "";		

			foreach($rawips as $ip)
			{
				if($ip[0] != NULL)
				{
					if($ip[0] == @$_GET['ip'])
					{
						$ips .= "<option selected>$ip[0]</option>";
					}
					else
					{
						$ips .= "<option>$ip[0]</option>";
					}
				}
			}
			
			$page_content = str_replace("[ips]", $ips, $page_content);		

			//Monat
			$i = 1;
			$thismonth = date("n");	
			$months = "";	

			while($i <= $thismonth)
			{
				$monthname = date("F", mktime(0, 0, 0, $i+1, 0, 0));
			
				if(@$_GET['month'] == "")
				{
					if($i == $thismonth)
					{
						$months .= "<option value=\"$i\" selected>".$monthname."</option>";
					}
					else
					{
						$months .= "<option value=\"$i\">".$monthname."</option>";
					}
						
					$i++;
				}
				else
				{

					if($i == @$_GET['month'])
					{
						$months .= "<option value=\"$i\" selected>".$monthname."</option>";
					}
					else
					{
						$months .= "<option value=\"$i\">".$monthname."</option>";
					}
						
					$i++;			
				}
			}
		
			$page_content = str_replace("[months]", $months, $page_content);

			//Get TRAFFIC
		
			$month = @$_GET['month'] ? $_GET['month'] : date("m");
	
			$rawtraffic = vcp_exec($socket, "TRAFFIC ".$_SESSION['user']." $month");	

			if($rawtraffic != "" && $rawtraffic != "N/A")
			{
				$rawtraffic = explode(" - ", $rawtraffic);
				$montraffic = explode(" ", $rawtraffic[0]);
	
				$totalmonth = 0;
				$traffic = "";
				$i = 0;
		
				while(@$montraffic[$i * 6] != "")
				{
					if(@$_GET['ip'] == "" || @$_GET['ip'] == "All" || @$_GET['ip'] == $montraffic[$i*6])
					{
						if(@$lastday == $montraffic[$i*6+1])	
						{
							$montraffic[$i*6+1] = "";
						}
						else
						{
							$montraffic[$i*6+1] .= ".";
							$lastday = $montraffic[$i*6+1];
						}
						
						$totalmonth += $montraffic[$i*6+5];
			
						$in = number_format($montraffic[$i*6+3]/1000/1000, 2, '.', '');
						$out = number_format($montraffic[$i*6+4]/1000/1000, 2, '.', '');
						$total = number_format($montraffic[$i*6+5]/1000/1000, 2, '.', '');
		
						$daytraffic = tpl_load("traffic_entry");
						tpl_set($daytraffic, "[ip]", $montraffic[$i*6]);
						tpl_set($daytraffic, "[day]", $montraffic[$i*6+1]);
						tpl_set($daytraffic, "[in]", $in);
						tpl_set($daytraffic, "[out]", $out);
						tpl_set($daytraffic, "[total]", $total);


						$traffic .= $daytraffic;
					}
						

					$i++;
				}
		
				$totalmonth = number_format($totalmonth/1000/1000, 2, '.', '');
				$totalmonthgb = number_format($totalmonth/1000, 2, '.', '');
			
			}
			else
			{
				$traffic = "";
				$totalmonth = 0;
				$totalmonthgb = 0;
			}



			tpl_set($page_content, "[totalmonth]", $totalmonth);
			tpl_set($page_content, "[totalmonthgb]", $totalmonthgb);

			$page_content = str_replace("[traffic]", $traffic, $page_content);
			$page_content = str_replace("[month]", @$_GET['month'], $page_content);
			$page_content = str_replace("[ip]", @$_GET['ip'], $page_content);
		
		}
		else
		{
				$page_content = tpl_load("message");
				tpl_set($page_content, "[type]", "Error");
				tpl_set($page_content, "[message]", "Couldn't connect to node");
		}

		
		$page = str_replace("[content]", $page_content, $page);
		
	
	
	
	echo $page;
	
?>
