<?
/** OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

define("AREA", "admin");

include_once "../lib/admin_init.inc.php";

	$page = tpl_load("body");
	$page_menu = tpl_load("menu");
	
	$page = str_replace("[MENU]", $page_menu, $page);


	if(isset($_GET['start']) && isset($_GET['vserver']))
	{
		$page_content = tpl_load("vserver_action");
		$page_content = str_replace("[action]", "Starting ", $page_content);
		
		$page = str_replace("[CONTENT]", $page_content, $page);	
		
		echo $page;
		ob_implicit_flush ();

		htmlelement_set("output", "");
		htmlelement_set("result", "");
		
		$hardware_node = get_node_by_id($_GET['nodeid']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);
		
		
		foreach($_GET['vserver'] as $vsname)
		{

			htmlelement_add("output", "Starting $vsname...\\r\\n");

			vcp_exec($socket, "CONTROL START $vsname");
			

			htmlelement_add("result", "Done\\r\\n");
			
		}
		
		htmlelement_hide("loadimg");
		htmlelement_set("message", "Complete");

	}
	elseif(isset($_GET['stop']) && isset($_GET['vserver']))
	{
		$page_content = tpl_load("vserver_action");
		$page_content = str_replace("[action]", "Stopping ", $page_content);
		
		$page = str_replace("[CONTENT]", $page_content, $page);	
		
		echo $page;
		ob_implicit_flush ();

		htmlelement_set("output", "");
		htmlelement_set("result", "");
		
		$hardware_node = get_node_by_id($_GET['nodeid']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);
		
		
		foreach($_GET['vserver'] as $vsname)
		{

			htmlelement_add("output", "Stopping $vsname...\\r\\n");

			vcp_exec($socket, "CONTROL STOP $vsname");			
			
			htmlelement_add("result", "Done\\r\\n");
			
		}
		
		htmlelement_hide("loadimg");
		htmlelement_set("message", "Complete");
	}
	elseif(isset($_GET['reboot']) && isset($_GET['vserver']))
	{
		$page_content = tpl_load("vserver_action");
		$page_content = str_replace("[action]", "Restarting ", $page_content);
		
		$page = str_replace("[CONTENT]", $page_content, $page);	
		
		echo $page;
		ob_implicit_flush ();

		htmlelement_set("output", "");
		htmlelement_set("result", "");
		
		$hardware_node = get_node_by_id($_GET['nodeid']);
		$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);
		
		
		foreach($_GET['vserver'] as $vsname)
		{

			htmlelement_add("output", "Rebooting $vsname...\\r\\n");

			if(vcp_exec($socket, "GET STATE $vsname") == 'Online')
			{
				vcp_exec($socket, "CONTROL STOP $vsname");			
			}
			vcp_exec($socket, "CONTROL START $vsname");			
			
			htmlelement_add("result", "Done\\r\\n");
			
		}
		
		htmlelement_hide("loadimg");
		htmlelement_set("message", "Complete");
	}
	elseif(isset($_GET['del']) && isset($_GET['vserver']))
	{

		if(@isset($_GET['submit']))
		{
			$page_content = tpl_load("vserver_action");
			$page_content = str_replace("[action]", "Delete ", $page_content);
			
			$page = str_replace("[CONTENT]", $page_content, $page);	
			
			echo $page;
			ob_implicit_flush ();
	
			htmlelement_set("output", "");
			htmlelement_set("result", "");
			
			$hardware_node = get_node_by_id($_GET['nodeid']);
			$socket = vcp_connect($hardware_node['ip'], $hardware_node['password'], $hardware_node['tls_support']);
		
			
			foreach($_GET['vserver'] as $vsname)
			{
	

	
				if(vcp_exec($socket, "GET STATE $vsname") == "Online")
				{
					htmlelement_add("output", "Stopping $vsname...\\r\\n");
					vcp_exec($socket, "CONTROL STOP $vsname");
					htmlelement_add("result", "OK\\r\\n");	
				}

				htmlelement_add("output", "Deleting $vsname...\\r\\n");
				vcp_exec($socket, "REMOVE $vsname");					

				mysql_query("DELETE FROM users WHERE name = '".mysql_escape_safe($vsname)."'");
				mysql_query("UPDATE networks SET used = 0, vserver = '' WHERE vserver='".mysql_escape_safe($vsname)."'");
				htmlelement_add("result", "OK\\r\\n");
				
			}
			
			htmlelement_hide("loadimg");
			htmlelement_set("message", "Complete");
		}
		else
		{
			$list = "";

			foreach($_GET['vserver'] as $vsname)
			{ 
				if($list != "") $list .= ", ";
				$list .= $vsname; 
			}

			$page_content = tpl_load("message");
			$page_content = str_replace("[TYPE]", "Notice ", $page_content);
			$page_content = str_replace("[MESSAGE]", "Do you really want to delete \"$list\"<br><br><a href=vserver.php?$_SERVER[QUERY_STRING]&submit>YES do it</a>", $page_content);

			$page = str_replace("[CONTENT]", $page_content, $page);	
			echo $page;
		}
	}
	else
	{
	
		$page_content = tpl_load("vserver_frame");

		// GRABING NODES
		$mysql_id = mysql_query("SELECT id, name FROM nodes");

		$nodes = "";	
	
		while(($mysql_result = mysql_fetch_assoc($mysql_id)) != NULL)
		{
			if(isset($_GET['node']) &&  $_GET['node'] == $mysql_result['id'])
			{
				$nodes .= "<option value=$mysql_result[id] selected>$mysql_result[name]</option>";	
			}
			else
			{
				$nodes .= "<option value=$mysql_result[id]>$mysql_result[name]</option>";	
			}
		}
		
		$page_content = str_replace("[nodes]", $nodes, $page_content);
		
		if(isset($_GET['node']) && $_GET['node'] != "")
		{
			$mysql_id = mysql_query("SELECT id,ip,password,tls_support FROM nodes WHERE id='".mysql_escape_safe($_GET['node'])."'") OR error_page("Database Error");
			$mysql_result = mysql_fetch_assoc($mysql_id);
			
			$page_content = str_replace("[nodeid]", $_GET['node'], $page_content);
		}
		else
		{
			$mysql_id = mysql_query("SELECT id,ip,password,tls_support FROM nodes LIMIT 1") OR error_page("Database Error");
			$mysql_result = mysql_fetch_assoc($mysql_id);
			
			$page_content = str_replace("[nodeid]", $mysql_result['id'], $page_content);

		}
		
		$page_content = str_replace("[nodes]", $nodes, $page_content);
		
		// GRABBING VSLIST

                $month_current = date("m");
                $month_past = date("m", mktime (0, 0, 0, $month_current-1));


		$vservers = "";

		if($mysql_result['ip'] != "")
		{
		
			$socket = vcp_connect($mysql_result['ip'], $mysql_result['password'], $mysql_result['tls_support']);
			$vslist = vcp_exec($socket, "LIST");
			rtrim($vslist);

	
			$vslist = explode(" ", $vslist);
			sort($vslist);

			$i = 1;
		
			foreach($vslist as $vsname)
			{
	
				if($vsname != "")
				{
					$vserver = tpl_load("vserver");
			
					$vserver = str_replace("[xid]", $i, $vserver);
					$vserver = str_replace("[name]", $vsname, $vserver);
					
					//Grabbing IPS
					$rawips = vcp_exec($socket, "GET IPS $vsname");

					if($rawips != "N/A")
					{
						$rawips = eth_split($rawips);
					

						$ips = "";
					
						foreach($rawips as $ip)
						{
							$ips .= "$ip[0]<br>";
							check_used_ip($ip[0],$mysql_result['id'],$vsname);
						}
						
					}
					else
					{
						$ips = "N/A";
					}

					$vserver = str_replace("[ips]", $ips, $vserver);
	
					//Grabbing Status
					$state = vcp_exec($socket, "GET STATE $vsname");


					if($state == "Online")
					{
						$vserver = str_replace("[state]", "Online", $vserver);
					}
					else
					{
						$vserver = str_replace("[state]", "Offline", $vserver);
					}
					
					//Grabbing Traffic

					$traffic_current = vcp_exec($socket, "TRAFFIC $vsname $month_current TOTAL");
					$traffic_past = vcp_exec($socket, "TRAFFIC $vsname $month_past TOTAL");

					tpl_set($vserver, "[traffic_current]", number_format($traffic_current/1000/1000/1000, 2));
					tpl_set($vserver, "[traffic_past]", number_format($traffic_past/1000/1000/1000, 2));
					tpl_set($vserver, "[node]", $mysql_result['id']);

					$vservers .= $vserver;
					
					$i++;
				}
			}
		
		}

		tpl_set($page_content, "[year_current]", date("Y"));
	
		tpl_set($page_content, "[month_current]", $month_current);
		tpl_set($page_content, "[month_past]", $month_past);

		tpl_set($page_content, "[vservers]", $vservers);		

	
		$page = str_replace("[CONTENT]", $page_content, $page);	
		echo $page;

	}
	
?>	
