<?
/**  OpenVCP Webinterface
 *  Copyright (C) 2006 Gerrit Wyen <gerrit@t4a.net>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

	/// include all important files
	include_once "/etc/openvcp-web/config.php";
	include_once "lib/functions.inc.php";
	include_once "lib/template.inc.php";
	include_once "lib/javascript.inc.php";


        define("OPENVCP_VERSION", "0.2 Beta");

	/// Create the MySQL Connection
	mysql_connect($mysql_host, $mysql_user, $mysql_pw) OR error_page("Connecting to Database failed");
	mysql_select_db($mysql_db) OR error_page("Selecting DB failed");

	/// Check for valid Session
	
	if (isset($_POST['user']) && isset($_POST['pw'])) 
	{
		$user = $_POST['user'];
		$pw = $_POST['pw'];

	
		if(isset($_SESSION['user'])) unset($_SESSION['user']);
		if(isset($_SESSION['pw'])) unset($_SESSION['pw']);	
		if(isset($_SESSION['admin'])) unset($_SESSION['admin']);	
		if(isset($_SESSION['adminpw'])) unset($_SESSION['adminpw']);	

		if(check_user($user, $pw))
		{
			session_start();
			session_register ('user', 'pw');
			$_SESSION['user'] = $user;
			$_SESSION['pw'] = $pw;
			session_write_close();
		}
		elseif($user == "Admin" && check_admin($user, $pw))
		{
			session_start();
			session_register ('admin', 'adminpw');
			$_SESSION['admin'] = $user;
			$_SESSION['adminpw'] = $pw;
			$url_scheme = (strtolower(@$_SERVER['HTTPS'])=='on') ? 'https://' : 'http://';
			session_write_close();
			header("Location: $url_scheme".$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])."/admin/index.php");
			echo "Admin logged in";
		}
	
	}
	elseif (!isset ($_SESSION)) session_start();

	if(check_user_redirect(@$_SESSION['user'], @$_SESSION['pw']) == FALSE) exit();
	
?>
